package spiderweb;

public class Circle {
	private Point center;
	private double radius;
	
	public Circle(Point center, double radius) {
		this.center = center;
		this.radius = radius;
	}
	
	public Point getCenter() {
		return center;
	}

	public void setCenter(Point center) {
		this.center = center;
	}

	public double getRadius() {
		return radius;
	}

	public void setRadius(double radius) {
		this.radius = radius;
	}
	
	// determine whether line and circle are crossing
	public boolean isCross(Line line) {
		double distStart = center.distance(line.getStart());
		double distEnd = center.distance(line.getEnd());
		if (distStart <= radius || distEnd <= radius) return true;
		double lengthOfLine = line.length();
		double halfArea = Math.abs(line.getStart().minus(center).det(line.getEnd().minus(center)));
		if (halfArea / lengthOfLine < radius) return true;
		return false;
	}
}
