package spiderweb;

public class Line {
	private Point start;
	private Point end;
	
	public Line(Point start, Point end) {
		this.start = start;
		this.end = end;
	}
	
	public Point getStart() {
		return start;
	}

	public void setStart(Point start) {
		this.start = start;
	}

	public Point getEnd() {
		return end;
	}

	public void setEnd(Point end) {
		this.end = end;
	}

	// return intersected point between two lines
	public Point intersection(Line ot) {
		double t1 = ot.end.minus(ot.start).det(ot.start.minus(start));
		double t2 = ot.end.minus(ot.start).det(end.minus(start));
		return start.plus(end.minus(start).scalar(t1 / t2));
	}
	
	// determine whether point x is on line
	public boolean onLine(Point x) {
		return start.minus(x).det(end.minus(x)) == 0 && (start.minus(x).dot(end.minus(x))) <= 0;
	}
	
	public double length() {
		return start.distance(end);
	}
	
	public String toString() {
		return "(" + start.toString() + "),(" + end.toString() + ")";
	}
	
	public String toSvg() {
		return "<line x1=\"" + start.getX() + "\" y1=\"" + start.getY() + "\" x2=\"" + end.getX() + "\" y2=\"" + end.getY() + "\" fill=\"none\" stroke=\"black\"/>";
	}
}